(ns com.aurellem.gb-driver
  (:import com.aurellem.gb.Gb)
  (:import (java.nio IntBuffer ByteOrder)))

(defn vba-init []
  (Gb/loadVBA)
  (future
    (Gb/startEmulator "/home/r/proj/pokemon-escape/roms/yellow.gbc")))

(defn cpu-data [size arr-fn]
  (let [store (int-array size)]
    (fn [] 
      (arr-fn store)
      store)))

(def ram
  (cpu-data (Gb/getRAMSize) #(Gb/getRAM %)))

(def rom 
  (cpu-data (Gb/getROMSize) #(Gb/getROM %)))

(def working-ram 
  (cpu-data Gb/WRAM_SIZE #(Gb/getWRAM %)))

(def video-ram 
  (cpu-data Gb/VRAM_SIZE #(Gb/getVRAM %)))

(def registers
  (cpu-data Gb/NUM_REGISTERS #(Gb/getRegisters %)))


